"use strict";

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var express = require('express');

var router = express.Router();

var shell = require('shelljs');

var fs = require('fs');

var path = require('path');

var _require = require('../utils/utils'),
    getGlobalItem = _require.getGlobalItem;

var HPM_API = getGlobalItem('api');
router.get('/list', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
    var name, result, manifest, readmes, readmeMap, files, others, _yield$HPM_API$getRem, _yield$HPM_API$getRem2, data, bundleMap, index, readme, content;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            name = req.query.name;
            result = {
              code: 200,
              message: 'success'
            };
            manifest = HPM_API.getLocalBundle(name);
            readmes = [];
            readmeMap = {
              name: 'readme',
              sortNo: 0,
              data: {}
            };

            if (!manifest) {
              _context.next = 16;
              break;
            }

            files = shell.ls(manifest.path);
            readmes = files.filter(function (file) {
              return file.toLocaleLowerCase().startsWith('readme') && file.endsWith('.md');
            });
            readmes.forEach(function (readme) {
              if (readme.toLocaleLowerCase() === 'readme.md') {
                readmeMap.data.default = {};
                readmeMap.data.default.path = path.join(manifest.path, readme);
                readmeMap.data.default.content = fs.readFileSync(readmeMap.data.default.path).toString();
              } else {
                var _name = path.parse(readme).name;

                var language = _name.substr(_name.lastIndexOf('_') + 1).toLocaleLowerCase();

                readmeMap.data[language] = {};
                readmeMap.data[language].path = path.join(manifest.path, readme);
                readmeMap.data[language].content = fs.readFileSync(readmeMap.data[language].path).toString();
              }
            });
            others = files.filter(function (file) {
              return ['LICENSE', 'bundle.json', 'CHANGELOG.md'].includes(file);
            });
            others = others.map(function (other) {
              var item = {};

              switch (other) {
                case 'LICENSE':
                  {
                    item.name = 'license';
                    item.path = path.join(manifest.path, 'LICENSE');
                    item.content = fs.readFileSync(item.path).toString();
                    item.sortNo = 1;
                    break;
                  }

                case 'bundle.json':
                  {
                    item.name = 'bundle';
                    item.path = path.join(manifest.path, 'bundle.json');
                    item.content = fs.readFileSync(item.path).toString();
                    item.sortNo = 2;
                    break;
                  }

                case 'CHANGELOG.md':
                  {
                    item.name = 'changeLog';
                    item.path = path.join(manifest.path, 'CHANGELOG.md');
                    item.content = fs.readFileSync(item.path).toString();
                    item.sortNo = 3;
                    break;
                  }

                default:
                  break;
              }

              return item;
            });
            readmes = [readmeMap].concat(_toConsumableArray(others)).sort(function (a, b) {
              return a.sortNo - b.sortNo;
            });
            result.data = readmes;
            _context.next = 35;
            break;

          case 16:
            _context.next = 18;
            return HPM_API.getRemoteBundleDetails(name);

          case 18:
            _yield$HPM_API$getRem = _context.sent;
            _yield$HPM_API$getRem2 = _yield$HPM_API$getRem.data;
            data = _yield$HPM_API$getRem2 === void 0 ? [] : _yield$HPM_API$getRem2;
            bundleMap = {
              name: 'bundle',
              content: data[0].manifest,
              sortNo: 2
            };

            if (!(data && data.length > 0)) {
              _context.next = 35;
              break;
            }

            index = 0;

          case 24:
            if (!(index < data[0].readmes.length)) {
              _context.next = 34;
              break;
            }

            readme = data[0].readmes[index];
            readmeMap.data[readme.language] = {};
            _context.next = 29;
            return HPM_API.getRemoteReadme(readme.url);

          case 29:
            content = _context.sent;
            readmeMap.data[readme.language].content = content;

          case 31:
            index++;
            _context.next = 24;
            break;

          case 34:
            readmes = [readmeMap, bundleMap];

          case 35:
            result.data = readmes;
            res.send(result);
            _context.next = 42;
            break;

          case 39:
            _context.prev = 39;
            _context.t0 = _context["catch"](0);
            next(_context.t0);

          case 42:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 39]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}());
module.exports = router;