"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var fs = require('fs');

var os = require('os');

var ApiHandler = require('../utils/apiHandler');

var path = require('path');

var appEvent = require('../event');

var _require = require('../utils/utils'),
    getGlobalItem = _require.getGlobalItem,
    mkMoreDir = _require.mkMoreDir,
    writeFile = _require.writeFile,
    findKey = _require.findKey,
    extract = _require.extract;

var _require2 = require('../utils/constant'),
    fileMap = _require2.fileMap;

var project = require('../service/project');

var HPM_API = getGlobalItem('api');

var ProductLine = /*#__PURE__*/function (_ApiHandler) {
  _inherits(ProductLine, _ApiHandler);

  var _super = _createSuper(ProductLine);

  function ProductLine() {
    var _this;

    _classCallCheck(this, ProductLine);

    _this = _super.call(this);
    _this.packageFolderPath = path.resolve(os.homedir(), '.hpm', 'dataPackages');
    setTimeout(function () {
      _this.assetDatapackages();
    }, 0);
    return _this;
  }

  _createClass(ProductLine, [{
    key: "cwd",
    get: function get() {
      return getGlobalItem('cwd');
    }
  }, {
    key: "applyProfileToBundle",
    value: function () {
      var _applyProfileToBundle = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
        var bundleJson, productionLineId, productionVersion, bundleJsonPath, templateZip, oldBundleJson, data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                bundleJson = _ref.bundleJson, productionLineId = _ref.productionLineId, productionVersion = _ref.productionVersion;
                bundleJsonPath = path.resolve(this.cwd, 'bundle.json'); // 判断当前目录是否存在bundle.json, 存在直接重写bundle.json,不存在根据模板生成bundle.json

                if (fs.existsSync(bundleJsonPath)) {
                  _context.next = 11;
                  break;
                }

                templateZip = path.resolve(this.packageFolderPath, productionLineId, productionVersion, 'template.zip');

                if (fs.existsSync(templateZip)) {
                  _context.next = 9;
                  break;
                }

                _context.next = 7;
                return HPM_API.init({
                  name: bundleJson.name,
                  template: 'dist',
                  dirname: this.cwd
                });

              case 7:
                _context.next = 11;
                break;

              case 9:
                _context.next = 11;
                return extract(templateZip, this.cwd);

              case 11:
                oldBundleJson = JSON.parse(fs.readFileSync(bundleJsonPath).toString());
                data = _objectSpread(_objectSpread({}, oldBundleJson), bundleJson);
                data.ohos && Object.keys(data.ohos).length === 0 && delete data.ohos;
                _context.next = 16;
                return writeFile(bundleJsonPath, JSON.stringify(data, null, 4));

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function applyProfileToBundle(_x) {
        return _applyProfileToBundle.apply(this, arguments);
      }

      return applyProfileToBundle;
    }()
  }, {
    key: "applyComponents",
    value: function () {
      var _applyComponents = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(body, applyName) {
        var bundleJsonPath, data;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                bundleJsonPath = path.join(getGlobalItem('cwd'), 'bundle.json');

                if (fs.existsSync(bundleJsonPath)) {
                  _context2.next = 3;
                  break;
                }

                throw new Error("Can not found \"bundle.json\" in ".concat(__filename));

              case 3:
                _context2.next = 5;
                return project.getBundleJSON();

              case 5:
                data = _context2.sent;

                if (applyName) {
                  data[applyName] = body;
                }

                _context2.next = 9;
                return writeFile(bundleJsonPath, JSON.stringify(data, null, 4));

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function applyComponents(_x2, _x3) {
        return _applyComponents.apply(this, arguments);
      }

      return applyComponents;
    }()
  }, {
    key: "assetDatapackages",
    value: function assetDatapackages() {
      if (!fs.existsSync(this.packageFolderPath)) {
        fs.mkdirSync(this.packageFolderPath);
      }

      var routePath = '/api/datapackages';
      var staticPath = this.packageFolderPath;
      appEvent.emit('assetAdd', {
        routePath: routePath,
        staticPath: staticPath,
        id: 'datapackages'
      });
    }
  }, {
    key: "isCached",
    value: function isCached(productionLineId, productionVersion) {
      var packagePath = path.resolve(this.packageFolderPath, productionLineId, productionVersion);
      return fs.existsSync(packagePath) && fs.existsSync(path.resolve(packagePath, 'subsystem.json')) && fs.existsSync(path.resolve(packagePath, 'manifest.json')) && fs.existsSync(path.resolve(packagePath, 'logic.js'));
    }
  }, {
    key: "downloadPackage",
    value: function () {
      var _downloadPackage = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref2) {
        var productionLineId, productionVersion, _yield$this$getFileUr, fileData, currentFileData, filePath, promiseArr, key;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                productionLineId = _ref2.productionLineId, productionVersion = _ref2.productionVersion;

                if (!fs.existsSync(this.packageFolderPath)) {
                  fs.mkdirSync(this.packageFolderPath);
                }

                if (this.isCached(productionLineId, productionVersion)) {
                  _context3.next = 12;
                  break;
                }

                _context3.next = 5;
                return this.getFileUrl({
                  productionLineId: productionLineId,
                  version: encodeURI(productionVersion)
                });

              case 5:
                _yield$this$getFileUr = _context3.sent;
                fileData = _yield$this$getFileUr.data;
                currentFileData = fileData.find(function (item) {
                  return item.productionLineId === productionLineId && item.productionVersion === productionVersion;
                });
                filePath = mkMoreDir(this.packageFolderPath, [productionLineId, productionVersion]);
                promiseArr = [];

                for (key in currentFileData.file) {
                  promiseArr.push(this.download(currentFileData.file[key], path.resolve(filePath, fileMap.get(key))));
                }

                return _context3.abrupt("return", Promise.all(promiseArr));

              case 12:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function downloadPackage(_x4) {
        return _downloadPackage.apply(this, arguments);
      }

      return downloadPackage;
    }() //  获取本地数据包的信息，数据结构与远端相同

  }, {
    key: "getLocalProductLine",
    value: function getLocalProductLine() {
      var _this2 = this;

      var result = [];
      fs.readdirSync(this.packageFolderPath, {
        withFileTypes: true
      }).forEach(function (x) {
        if (x.isDirectory()) {
          fs.readdirSync(path.resolve(_this2.packageFolderPath, x.name), {
            withFileTypes: true
          }).forEach(function (y) {
            if (y.isDirectory()) {
              var filePath = path.resolve(_this2.packageFolderPath, x.name, y.name);
              var fileDir = fs.readdirSync(filePath);

              if (fs.existsSync(path.resolve(filePath, 'manifest.json'))) {
                var _JSON$parse = JSON.parse(fs.readFileSync(path.resolve(filePath, 'manifest.json')).toString()),
                    productionLineId = _JSON$parse.productionLineId,
                    productionVersion = _JSON$parse.version,
                    _JSON$parse$name = _JSON$parse.name,
                    enName = _JSON$parse$name.en,
                    name = _JSON$parse$name.zh,
                    _JSON$parse$descripti = _JSON$parse.description,
                    enDescription = _JSON$parse$descripti.en,
                    description = _JSON$parse$descripti.zh,
                    createTime = _JSON$parse.publishTime;

                var file = {};
                fileDir.forEach(function (item) {
                  file = _objectSpread(_objectSpread({}, file), {}, _defineProperty({}, findKey(fileMap, item), "/api/datapackages/".concat(x.name, "/").concat(y.name, "/").concat(item)));
                });
                var item = {
                  createTime: createTime,
                  description: description,
                  enDescription: enDescription,
                  enName: enName,
                  file: file,
                  name: name,
                  productionLineId: productionLineId,
                  productionVersion: productionVersion
                };
                result.push(item);
              }
            }
          });
        }
      });
      return result;
    }
  }]);

  return ProductLine;
}(ApiHandler);

module.exports = ProductLine;